/*  example of loading a font into memory  */
#include <graphics.h>
#include <io.h>
#include <fcntl.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <process.h>
#include <alloc.h>
int i,lwidth,wwidth,ch;
char buffer[80];
main( argc, argv )
int argc;
char *argv[];
{
    void   *gothic_fontp;   /* points to the font buffer in memory */
    int    handle;         /* file handle used for I/O    */
    unsigned fsize;	   /* size of file (and buffer)   */

    int errorcode;
    int graphdriver;
    int graphmode;
    char name[13];
    int num=0;
    int charsize=1;
	/* open font file  */
    if (argc != 4)
    {
       printf("Syntax: SETVMODE name n\n");
       exit(1);
    }
    sscanf( argv[1], "%s", name);
    sscanf( argv[2], "%x", &num );
    sscanf( argv[3], "%x", &charsize );
    handle = open( name, O_RDONLY|O_BINARY);
    if (handle == -1)
    {
      printf("unable to open font file '%s %x'\n",name,&num);
      exit(1);
    }
    /* find out size of the file */
    fsize = filelength(handle);

    /* allocate buffer   */
    gothic_fontp = malloc(fsize);
    if (gothic_fontp == NULL)
    {
       printf("unable to allocate memory for font file '%s'\n", name);
       exit(1);
    }
 /* read font into memory   */
    if (read(handle, gothic_fontp, fsize) != fsize)
    {
       printf("unable to read font file '%s'\n", name);
       exit(1);
    }
    /* close font file */
       close(handle);
    /* register font   */
    i=registerfarbgifont(gothic_fontp);
    if (registerfarbgifont(gothic_fontp) != num )   /*GOTHIC_FONT)*/
    {
       printf("unable to register font file '%s'\n", name);
       exit(1);
    }
 /* detect and initiaize graphix   */
    graphdriver = DETECT;
    initgraph(&graphdriver, &graphmode, "..");
    errorcode = graphresult();
    if (errorcode != grOk)
    {
       printf("graphics error: %s\n",grapherrormsg(errorcode));
       exit(1);
    }
    settextjustify(CENTER_TEXT, CENTER_TEXT);
    settextstyle( num, HORIZ_DIR, charsize );
    outtextxy( getmaxx()/2, getmaxy()/2, "Borland Graphics Interface(BGI)");
    settextjustify( LEFT_TEXT, TOP_TEXT);
    moveto( 2,3 );
    buffer[1]='\0';
    wwidth=getmaxx();
    lwidth=textwidth("H");
    ch=0x0;
    while(ch<256) {
        buffer[0]=ch;
        outtext(buffer);
        if ((lwidth+getx()) > wwidth)
          moveto(2,gety()+textheight("H")+3);
        ++ch;
    } 
    /* hit a key to terminate  */
       getch();
    /* shut down graphics system   */
       closegraph();
       return(0);
 }
